---
title: 2-3 tree analysis
nav_order: 7
---

Depending on the number of 2-nodes vs. 3-nodes in a 2-3 tree, the number of elements that can be stored in a 2-3 tree of given height may vary greatly. For example, a 2-3 tree of height 2 can contain anywhere between 7 elements (all 2-nodes) and 26 elements (all 3-nodes).

{% capture question %}
Identify the best-case order of growth for the height of a 2-3 tree containing *N* elements.

- [ ] *Θ*(1)
- [ ] *Θ*(log *N*)
- [ ] *Θ*(*N*)
{% endcapture %}
{% capture explanation %}
All of the nodes are 3-nodes (as "stuffed" as possible), so the height of the tree is about log<sub>3</sub>*N*.
{% endcapture %}
{% include question.html question=question explanation=explanation number=1 %}

{% capture question %}
Identify the worst-case order of growth for the height of a 2-3 tree containing *N* elements.

- [ ] *Θ*(1)
- [ ] *Θ*(log *N*)
- [ ] *Θ*(*N*)
{% endcapture %}
{% capture explanation %}
All of the nodes are 2-nodes (like a perfectly-balanced binary search tree), so the height of the tree is about log<sub>2</sub>*N*.
{% endcapture %}
{% include question.html question=question explanation=explanation number=2 %}
