---
title: LLRB tree insertion
nav_order: 9
---

In an LLRB tree, elements are inserted as red leaf nodes. When **returning** from each recursive call to `add`, the code addresses each of these conditions as necessary.

1. If the right child is red and the left child is black, **rotate left**.
1. If the left child and its left grandchild are red, **rotate right**.
1. If both children are red, **flip colors**.

{% capture question %}
If we add 15 to this LLRB tree, what operation will we need to perform to maintain LLRB invariants? Give a method call to either `rotateLeft(n)`, `rotateRight(n)`, or `flip(n)` where `n` is replaced with the value of the node.

![Small LLRB Tree](https://docs.google.com/drawings/d/e/2PACX-1vTTI0zXcdMdec1Ke97sCloYSWYxcTnSu_cMyqzTW1C6DwBozot2QK_UwxkJ8veiKe0alLYnsquDVwld/pub?w=288&h=288)
{% endcapture %}
{% include question.html question=question number=1 %}

{% capture question %}
Which of the following values requires an immediate `rotateRight` operation when inserted into this LLRB tree?

![Small LLRB Tree](https://docs.google.com/drawings/d/e/2PACX-1vTTI0zXcdMdec1Ke97sCloYSWYxcTnSu_cMyqzTW1C6DwBozot2QK_UwxkJ8veiKe0alLYnsquDVwld/pub?w=288&h=288)

- [ ] 0
- [ ] 15
- [ ] 19
- [ ] 24
- [ ] 36
- [ ] 40
- [ ] 45
{% endcapture %}
{% include question.html question=question number=2 %}

{% capture question %}
What is the value of the overall root for the LLRB tree that results from inserting these items in the given order: 1, 2, 3, 7, 8, 9, 5?
{% endcapture %}
{% capture explanation %}
Insert into the 2-3 tree ([B-tree visualization](https://www.cs.usfca.edu/~galles/visualization/BTree.html)) and use 1-1 correspondence to determine the value of the overall root node.
{% endcapture %}
{% include question.html question=question explanation=explanation number=3 %}

{% capture question %}
If we add 15 to this LLRB tree, what operation(s) will we need to perform to maintain LLRB invariants? Give a list of method calls to `rotateLeft(n)`, `rotateRight(n)`, or `flip(n)` where `n` is replaced with the value of the node.

![Small LLRB Tree](https://docs.google.com/drawings/d/e/2PACX-1vTTI0zXcdMdec1Ke97sCloYSWYxcTnSu_cMyqzTW1C6DwBozot2QK_UwxkJ8veiKe0alLYnsquDVwld/pub?w=288&h=288)
{% endcapture %}
{% include question.html question=question number=4 %}
